#include "VisMostCrowdedStreet.h"

VisMostCrowdedStreet::VisMostCrowdedStreet(int n): maxPipes(n) {
	pipes = new PPipe[maxPipes];
	pipeCount = 0;
}

void VisMostCrowdedStreet::visitPipe(PPipe e)
{
	{
		int pos = 0;
		while (pos < pipeCount && e->getNumOfOccurrences() < pipes[pos]->getNumOfOccurrences()) 
			pos++;
		
		int pos1 = (pipeCount < maxPipes) ? pipeCount : maxPipes-1;
		while (pos1 > pos) { pipes[pos1] = pipes[pos1-1]; pos1--; }
		
		if (pos < maxPipes) pipes[pos] = e;
		
		if (pipeCount < maxPipes) ++pipeCount;
	}
}

#include "iostream.h"

void VisMostCrowdedStreet::report()
{
	for (int i = 0; i < pipeCount; ++i)
		cout << pipes[i]->getName() << " " << pipes[i]->getNumOfOccurrences() << endl;
}

